# Installation guide

1. Install Orange Data Mining via https://orangedatamining.com/download

<img src="../images/orange_installation.png" alt="orange_installation" width="800"/>

Click on "Download Orange".

2. Once installed (it takes about 15 min and will ask you to also install Miniconda in the process), open Orange from your computer menu or the link on the desktop. You will see something like this:

<img src="../images/orange_canvas.png" alt="orange_canvas" width="800"/>

3. Go to the "Options" menu in the top menu bar and select "Add-ons":

<img src="../images/orange_addons.png" alt="orange_addons" width="600"/>

4. In the pop-up that opens, click on "Add more...", in the upper right. A search window will appear called "Add add-on by name." Type "mecoda-orange" in the search bar and click "Add."

<img src="../images/orange_add_more2.png" alt="orange_add_more" width="600"/>

5. ***Mecoda Orange*** will appear available in the list of installation packages, last. Check the box next to the name and click OK to install it. If the process is successful, Orange will ask you to restart it when it is finished.

<img src="../images/orange_mecoda_package.png" alt="orange_mecoda_package" width="600"/>

6. We will need other packages for our exercise, so after installing MECODA we go again to "Options" > "Add-ons" and select the ***Geo*** and ***Image Analytics* packages from the list **.

<img src="../images/orange_other_packages.png" alt="orange_other_packages" width="600"/>

7. After selecting these two packages, click **OK** to install them. Orange will ask us to restart again.

<img src="../images/orange_reinicio.png" alt="orange_reinicio" width="600"/>

8. Orange will reboot and the interface will show our installed packages in the left column:

<img src="../images/orange_interface_installed.png" alt="orange_interface_installed" width="600"/>

# Official Orange Documentation:

There are numerous resources to familiarize yourself with this platform. These are some of the most notable ones.

How to use each of the available widgets:
* Widget catalogue: https://orangedatamining.com/widget-catalog/

Video tutorials from 0 to advanced machine learning processes:
* YouTube Tutorials: https://www.youtube.com/channel/UClKKWBe2SCAEyv7ZNGhIe4g
     * Getting started with Orange: https://www.youtube.com/playlist?list=PLmNPvQr9Tf-ZSDLwOzxpvY-HrE0yv-8Fy

Examples of analyses that you can download and open in Orange to reproduce:
* Workflows: https://orangedatamining.com/workflows/
